#ifndef __FWINDOWS_H__
#define __FWINDOWS_H__

#include "stdafx.h"
#include "FKeyboard.h"
#include <time.h>

class __declspec(dllexport) FWindows
{
public:
	typedef void(*Function_I_float_O_void)(float);
	typedef void(*Function_I_HDC_O_void)(HDC);

	FWindows(HINSTANCE hInst, int nCmdShow, int width, int height, Function_I_float_O_void updateFunc, Function_I_HDC_O_void drawFunc);
	~FWindows();
	void run();
	HWND getHandler();
	
private:
	ATOM GenerateRegisterClass(HINSTANCE hInstance);
	BOOL InitInstance(HINSTANCE hInstance, int nCmdShow, int width, int height);

private:
	HINSTANCE	m_instance;
	MSG			m_message;
	HWND		m_handler;
	HDC			m_windowsDC;
	clock_t		m_timer;

	HDC			m_backBufferDC;
	HBITMAP		m_backBuffer;
	int			m_scrW;
	int			m_scrH;

	Function_I_float_O_void	m_updateFunc;
	Function_I_HDC_O_void	m_drawFunc;
};

#endif // __FWINDOWS_H__