#ifndef __CBASE_H__
#define __CBASE_H__

#include <exception>
#include <vector>

#include "FDataTypes.h"
#include "Config.h"

using namespace std;

class Entity;
class CBase
{
public:
	class PropertyFlag
	{
	public:
		enum { NUM_OF_CBASE_PROPERTY_FLAG = 0	};
	};

	enum COMMAND
	{
		NULL_COMMAND = -1
	};

	virtual int update(float deltaTime);
	virtual int commandProcess(int command);

	// CBase.h
	// class CBase
	// public

	// To get component Property.
	// The data location will be auto released by destroy returning variable.
	// @param propertyFlag: the flag define the property you wanna get, listed in CBasePropertyFlag.
	virtual ComponentProperty	getProperty(int propertyFlag);

	// To set component Property.
	// @param propertyData: a variable contain pointer to data location.
	// @param propertyFlag: the flag define the property you wanna set, listed in CBasePropertyFlag.
	virtual int	setProperty(ComponentProperty propertyData, int propertyFlag) throw(ComponentProperty::InvalidPointerType);

	ID::COMPONENT getTypeID();

	// To push an Component Command into command queue.
	// Possible pushed command are listed in each <Component class name>::COMMAND.
	// The commands are orderly.
	// @param command: the command to be pushed in command queue.
	int pushCommand(int command);

	// To get the next command in queue.
	// @return: the popped command. NULL_COMMAND which mean the queue was empty.
	int popCommand();

protected:
	Entity*			m_owner;
	ID::COMPONENT	m_typeID;
	vector<int>		m_commandQueue;
};

#endif // __CBASE_H__
