#include "CPosition.h"
#include "Config.h"

CPosition* CPosition::addComponentTo(Entity* object, int initPosX, int initPosY)
{
	auto component = new CPosition();

	component->m_owner = object;
	component->m_position = Vector2(initPosX, initPosY);

	object->addComponent(component);

	return component;
}

// CPosition.cpp
ComponentProperty CPosition::getProperty(int propertyFlag)
{
	switch (propertyFlag)
	{
	case PropertyFlag::PFLAG_POSITION:
		return ComponentProperty(new Vector2(m_position), ComponentProperty::PTYPE_VECTOR2, true);

	default:
		return ComponentProperty(nullptr, ComponentProperty::PTYPE_VOID, false);
		break;
	}
}

int CPosition::setProperty(ComponentProperty propertyData, int propertyFlag) throw(ComponentProperty::InvalidPointerType)
{
	switch (propertyFlag)
	{
	case PropertyFlag::PFLAG_POSITION:
		if (propertyData.typeFlag == ComponentProperty::PTYPE_VECTOR2)
		{
			m_position = *propertyData.ptrVector2;
			return FSUCCESS;
		}
		else
			throw ComponentProperty::InvalidPointerType();
		break;

	default:
		return FERROR_INVALID_FLAG;
		break;
	}
}

CPosition::CPosition()
{
	m_typeID = ID::COMPONENT::POSITION;
}

CPosition::~CPosition()
{

}
